// Generated by CoffeeScript 1.12.7
(function() {
  var L, hostname, renderable,
    hasProp = {}.hasOwnProperty;

  renderable = (L = require('acoustic-line')).renderable;

  hostname = require('os').hostname;

  module.exports = renderable(function(cfg) {
    var callerControls, configuration, control, doctype, document, global_settings, group, list, load, macros, map, mappings, module, modules, modules_to_load, name, network_lists, node, param, params, phrases_to_load, profile, profiles, ref, ref1, ref2, section, settings, the_profiles;
    doctype = L.doctype, document = L.document, section = L.section, configuration = L.configuration, settings = L.settings, params = L.params, param = L.param, modules = L.modules, module = L.module, load = L.load, network_lists = L.network_lists, list = L.list, node = L.node, global_settings = L.global_settings, profiles = L.profiles, profile = L.profile, mappings = L.mappings, map = L.map, macros = L.macros, callerControls = L.callerControls, group = L.group, control = L.control;
    name = (ref = cfg.name) != null ? ref : 'server';
    the_profiles = (ref1 = cfg.profiles) != null ? ref1 : {
      sbc: {
        sip_port: 5080,
        socket_port: 5721
      }
    };
    modules_to_load = ['mod_logfile', 'mod_event_socket', 'mod_commands', 'mod_dptools', 'mod_loopback', 'mod_sofia', 'mod_sndfile', 'mod_tone_stream', 'mod_httapi'];
    if (((ref2 = cfg.cdr) != null ? ref2.url : void 0) != null) {
      modules_to_load.push('mod_json_cdr');
    }
    if (cfg.modules != null) {
      modules_to_load = modules_to_load.concat(cfg.modules);
    }
    phrases_to_load = [require('bumpy-lawyer/en'), require('bumpy-lawyer/fr')];
    if (cfg.phrases != null) {
      phrases_to_load = phrases_to_load.concat(cfg.phrases);
    }
    doctype();
    return document({
      type: 'freeswitch/xml'
    }, function() {
      var ref3, sound_dir;
      section({
        name: 'configuration'
      }, function() {
        var ref3;
        configuration({
          name: 'switch.conf'
        }, function() {
          return settings(function() {
            var ref3;
            param({
              name: 'switchname',
              value: "freeswitch-" + name + "@" + ((ref3 = cfg.host) != null ? ref3 : hostname())
            });
            param({
              name: 'core-db-name',
              value: "/dev/shm/freeswitch/core-" + name + ".db"
            });
            param({
              name: 'rtp-start-port',
              value: 49152
            });
            param({
              name: 'rtp-end-port',
              value: 65534
            });
            param({
              name: 'max-sessions',
              value: 2000
            });
            param({
              name: 'sessions-per-second',
              value: 2000
            });
            param({
              name: 'min-idle-cpu',
              value: 1
            });
            return param({
              name: 'loglevel',
              value: 'err'
            });
          });
        });
        configuration({
          name: 'modules.conf'
        }, function() {
          return modules(function() {
            var i, len, results;
            results = [];
            for (i = 0, len = modules_to_load.length; i < len; i++) {
              module = modules_to_load[i];
              results.push(load({
                module: module
              }));
            }
            return results;
          });
        });
        configuration({
          name: 'logfile.conf'
        }, function() {
          settings(function() {
            return param({
              name: 'rotate-on-hup',
              value: true
            });
          });
          return profiles(function() {
            return profile({
              name: 'default'
            }, function() {
              settings(function() {
                param({
                  name: 'logfile',
                  value: "log/freeswitch.log"
                });
                param({
                  name: 'rollover',
                  value: 10 * 1000 * 1000
                });
                return param({
                  name: 'uuid',
                  value: true
                });
              });
              return mappings(function() {
                return map({
                  name: 'important',
                  value: 'err,crit,alert'
                });
              });
            });
          });
        });
        configuration({
          name: 'event_socket.conf'
        }, function() {
          return settings(function() {
            var ref3, socket_port;
            param({
              name: 'nat-map',
              value: false
            });
            param({
              name: 'listen-ip',
              value: '127.0.0.1'
            });
            socket_port = (ref3 = cfg.socket_port) != null ? ref3 : 5722;
            param({
              name: 'listen-port',
              value: socket_port
            });
            return param({
              name: 'password',
              value: 'ClueCon'
            });
          });
        });
        configuration({
          name: "acl.conf"
        }, function() {
          return network_lists(function() {
            var cidrs, ref3, results;
            ref3 = cfg.acls;
            results = [];
            for (name in ref3) {
              cidrs = ref3[name];
              results.push(list({
                name: name,
                "default": 'deny'
              }, function() {
                var cidr, i, len, results1;
                results1 = [];
                for (i = 0, len = cidrs.length; i < len; i++) {
                  cidr = cidrs[i];
                  results1.push(node({
                    type: 'allow',
                    cidr: cidr
                  }));
                }
                return results1;
              }));
            }
            return results;
          });
        });
        configuration('fifo.conf', function() {
          return settings(function() {
            return param('delete-all-outbound-member-on-startup', true);
          });
        });
        if (((ref3 = cfg.cdr) != null ? ref3.url : void 0) != null) {
          configuration({
            name: 'json_cdr.conf'
          }, function() {
            return settings(function() {
              var ref4, ref5, ref6, ref7, ref8;
              param({
                name: 'auth-scheme',
                value: (ref4 = cfg.cdr.auth_scheme) != null ? ref4 : 'basic'
              });
              param({
                name: 'encode-values',
                value: (ref5 = cfg.cdr.encode_values) != null ? ref5 : false
              });
              param({
                name: 'log-dir',
                value: (ref6 = cfg.cdr.log_dir) != null ? ref6 : 'cdr'
              });
              param({
                name: 'log-b-leg',
                value: (ref7 = cfg.cdr.log_b_leg) != null ? ref7 : false
              });
              param({
                name: 'cred',
                value: (ref8 = cfg.cdr.cred) != null ? ref8 : ''
              });
              return param({
                name: 'url',
                value: cfg.cdr.url
              });
            });
          });
        }
        configuration({
          name: 'sofia.conf'
        }, function() {
          global_settings(function() {
            param({
              name: 'log-level',
              value: 1
            });
            return param({
              name: 'debug-presence',
              value: 0
            });
          });
          return profiles(function() {
            var k, p, profile_module, q, ref4, ref5, ref6, results, v;
            profile_module = (ref4 = cfg.profile_module) != null ? ref4 : require('./profile');
            results = [];
            for (name in the_profiles) {
              p = the_profiles[name];
              if (p.timer_t1 == null) {
                p.timer_t1 = 250;
              }
              if (p.timer_t4 == null) {
                p.timer_t4 = 5000;
              }
              if (p.timer_t2 == null) {
                p.timer_t2 = 4000;
              }
              if (p.timer_t1x64 == null) {
                p.timer_t1x64 = 64 * p.timer_t1;
              }
              if (p.local_ip == null) {
                p.local_ip = 'auto';
              }
              if (p.inbound_codec == null) {
                p.inbound_codec = 'PCMA';
              }
              if (p.inbound_codec_negotiation == null) {
                p.inbound_codec_negotiation = 'scrooge';
              }
              if (p.outbound_codec == null) {
                p.outbound_codec = 'PCMA';
              }
              if (p.acl == null) {
                p.acl = 'default';
              }
              if (p.sip_trace == null) {
                p.sip_trace = false;
              }
              q = {};
              for (k in p) {
                if (!hasProp.call(p, k)) continue;
                v = p[k];
                q[k] = v;
              }
              q.name = q.context = name + "-ingress";
              q.sip_port = (ref5 = p.ingress_sip_port) != null ? ref5 : p.sip_port;
              if (cfg.acl_per_profile) {
                q.acl = q.name;
              }
              q.disable_transfer = q.client !== true;
              profile_module.call(L, q);
              q.name = q.context = name + "-egress";
              q.sip_port = (ref6 = p.egress_sip_port) != null ? ref6 : 10000 + q.sip_port;
              if (cfg.acl_per_profile) {
                q.acl = q.name;
              }
              q.disable_transfer = false;
              results.push(profile_module.call(L, q));
            }
            return results;
          });
        });
        configuration({
          name: 'httapi.conf'
        }, function() {
          settings(function() {
            return '';
          });
          return profiles(function() {
            return profile({
              name: 'default'
            }, function() {
              return params(function() {
                var ref4, ref5, ref6, ref7, ref8, ref9;
                param('gateway-url', (ref4 = cfg.httapi_url) != null ? ref4 : '');
                param('gateway-credentials', (ref5 = cfg.httapi_credentials) != null ? ref5 : '');
                param('auth-scheme', (ref6 = cfg.httapi_authscheme) != null ? ref6 : 'basic');
                param('enable-cacert-check', (ref7 = cfg.httapi_cacert_check) != null ? ref7 : true);
                param('enable-ssl-verifyhost', (ref8 = cfg.httpapi_verify_host) != null ? ref8 : true);
                param('timeout', (ref9 = cfg.httapi_timeout) != null ? ref9 : 120);
                param('file-cache-ttl', 1);
                param('abs-file-cache-ttl', 1);
                return param('file-not-found-expires', 1);
              });
            });
          });
        });
        configuration({
          name: 'conference.conf'
        }, function() {
          callerControls(function() {
            return group({
              name: 'default'
            }, function() {
              control({
                action: 'mute',
                digits: '1'
              });
              control({
                action: 'deaf mute',
                digits: '2'
              });
              return control({
                action: 'hangup',
                digits: '3'
              });
            });
          });
          return profiles(function() {
            return profile({
              name: 'default'
            }, function() {
              param('rate', 16000);
              param('interval', 20);
              param('enter-sound', 'tone_stream://%(200,0,500,600,700)');
              param('exit-sound', 'tone_stream://%(500,0,300,200,100,50,25)');
              return param('sound-prefix', '');
            });
          });
        });
        return configuration({
          name: 'msrp.conf'
        }, function() {
          return settings(function() {
            return param('listen-ip', '::1');
          });
        });
      });
      sound_dir = (ref3 = cfg.sound_dir) != null ? ref3 : '/opt/freeswitch/share/freeswitch/sounds';
      if (process.env.WITH_SOUNDS === 'true' || (process.env.WITH_SOUNDS == null)) {
        return section('phrases', function() {
          return macros(function() {
            var i, len, results;
            results = [];
            for (i = 0, len = phrases_to_load.length; i < len; i++) {
              module = phrases_to_load[i];
              results.push((module.include(sound_dir))(cfg));
            }
            return results;
          });
        });
      }
    });
  });

}).call(this);
