// Generated by CoffeeScript 1.12.7
(function() {
  var Unique_ID, debug, default_eavesdrop_timeout, hand, heal, pkg, ref, seem;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:egress:centrex-redirect";

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand, heal = ref.heal;

  Unique_ID = 'Unique-ID';

  default_eavesdrop_timeout = 8 * 3600;

  this.include = seem(function*() {
    var eavesdrop_key, eavesdrop_timeout, is_remote, key, queuer, queuer_call, ref1, ref2, res, server, uri;
    if (((ref1 = this.session) != null ? ref1.direction : void 0) !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    is_remote = (yield this.cfg.is_remote(this.session.number_domain, [this.session.local_server, this.session.client_server].join('/')));
    if (is_remote) {
      server = is_remote.split('/')[1];
      this.report({
        state: 'centrex-redirect',
        server: server
      });
      uri = "<sip:" + this.destination + "@" + server + ";xref=" + this.session.reference + ">";
      this.debug('Handling is remote', uri);
      if (this.data['Answer-State'] === 'answered') {
        uri = "<sip:" + this.destination + "@" + this.session.number_domain + ";xref=" + this.session.reference + "?Via=" + server + ">";
        res = (yield this.action('deflect', uri));
      } else {
        res = (yield this.action('redirect', uri));
      }
      this.debug('Redirection returned', uri, res);
      this.direction('transferred');
      return;
    }
    this.debug('Handling is local');
    eavesdrop_timeout = this.cfg.eavesdrop_timeout;
    if (eavesdrop_timeout == null) {
      eavesdrop_timeout = default_eavesdrop_timeout;
    }
    key = this.session.agent;
    eavesdrop_key = "outbound:" + key;
    queuer = this.cfg.queuer;
    if (!this.call.closed) {
      this.debug('Set outbound eavesdrop', eavesdrop_key);
      yield ((ref2 = this.local_redis) != null ? ref2.setex(eavesdrop_key, eavesdrop_timeout, this.call.uuid) : void 0);
      debug('CHANNEL_PRESENT', key, this.call.uuid);
      if ((queuer != null) && (this.queuer_call != null)) {
        queuer_call = (yield this.queuer_call());
        if (this.session.referred_by === key) {
          this.debug('Agent is the one doing the transfer, not forcing agent back to busy.', key);
        } else {
          yield queuer.set_agent(queuer_call, key);
        }
        if (this.session.transfer) {
          yield queuer.monitor_remote_call(queuer_call);
        } else {
          yield queuer.monitor_local_call(queuer_call);
        }
      }
      this.report({
        event: 'start-of-call',
        agent: key,
        call: this.call.uuid
      });
    }
    return this.debug('Ready');
  });

}).call(this);
