// Generated by CoffeeScript 1.12.7
(function() {
  var Moment, RedisInterface, TaggedAgent, TaggedCall, debug, domain_of, hand, now, pkg, queuer, ref, ref1, request, run, seem, sleep,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  this.name = 'huge-play:middleware:client:queuer';

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand;

  seem = require('seem');

  pkg = {
    name: 'huge-play'
  };

  Moment = require('moment-timezone');

  queuer = require('black-metal/queuer');

  request = require('superagent');

  run = require('flat-ornament');

  sleep = function(timeout) {
    return new Promise(function(resolve) {
      return setTimeout(resolve, timeout);
    });
  };

  domain_of = function(key) {
    return key != null ? key.split('@')[1] : void 0;
  };

  now = function(tz) {
    if (tz == null) {
      tz = 'UTC';
    }
    return Moment().tz(tz).format();
  };

  ref1 = require('black-metal/tagged'), TaggedCall = ref1.TaggedCall, TaggedAgent = ref1.TaggedAgent;

  RedisInterface = require('normal-key/interface');

  this.notify = function() {
    var Agent, get_pool, host, ref2;
    ref2 = this.cfg, host = ref2.host, queuer = ref2.queuer;
    if (queuer == null) {
      debug.dev('queuer is not available');
      return;
    }
    Agent = this.cfg.queuer.Agent;
    if (Agent == null) {
      debug.dev('Agent is not available');
      return;
    }
    this.configure({
      dial_calls: true
    });
    this.register('queuer:get-agent-state', 'dial_calls');
    this.register('queuer:log-agent-out', 'dial_calls');
    this.register('queuer:log-agent-in', 'dial_calls');
    this.socket.on('queuer:get-agent-state', hand((function(_this) {
      return function*(key) {
        var agent, is_remote, state;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queuer:get-agent-state', key);
        agent = new Agent(queuer, key);
        state = (yield agent.state()["catch"](function() {
          return null;
        }));
        agent.notify({
          state: state
        });
        debug('queuer:get-agent-state: done', key, state);
      };
    })(this)));
    this.socket.on('queuer:log-agent-out', hand((function(_this) {
      return function*(key) {
        var agent, is_remote;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queue:log-agent-out', key);
        agent = new Agent(queuer, key);
        yield agent.clear_tags();
        yield agent.transition('logout');
        debug('queue:log-agent-out: done', key);
      };
    })(this)));
    this.socket.on('queuer:log-agent-in', hand((function(_this) {
      return function*(key) {
        var agent, broadcast, ctx, i, is_remote, j, len, len1, queue, queues, ref3, skill, skills, tags, timezone;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queue:log-agent-in', key);
        tags = [];
        ref3 = (yield _this.cfg.prov.get("number:" + key)), skills = ref3.skills, queues = ref3.queues, broadcast = ref3.broadcast, timezone = ref3.timezone;
        if (skills != null) {
          for (i = 0, len = skills.length; i < len; i++) {
            skill = skills[i];
            tags.push("skill:" + skill);
          }
        }
        if (queues != null) {
          for (j = 0, len1 = queues.length; j < len1; j++) {
            queue = queues[j];
            tags.push("queue:" + queue);
          }
        }
        if (broadcast) {
          tags.push('broadcast');
        }
        agent = new Agent(queuer, key);
        yield agent.add_tags(tags);
        if (typeof ornaments !== "undefined" && ornaments !== null) {
          ctx = {
            agent: agent,
            timezone: timezone
          };
          yield run.call(ctx, ornaments, _this.ornaments_commands);
        }
        yield agent.accept_onhook();
        yield _this.report({
          state: 'queuer-login',
          source: source,
          fifo: fifo,
          tags: tags
        });
        debug('queue:log-agent-in: done', key);
      };
    })(this)));
    get_pool = (function(_this) {
      return function(name, pool) {
        _this.register("queuer:get-" + name + "-pool", 'dial_calls');
        _this.register("queuer:" + name + "-pool", 'calls');
        return _this.socket.on("queuer:get-" + name + "-pool", hand(function*(domain) {
          var calls, is_remote, notification, result;
          debug("queuer:get-" + name + "-pool", domain);
          is_remote = (yield _this.cfg.is_remote(domain));
          if (is_remote !== false) {
            return;
          }
          calls = (yield pool(domain).calls());
          result = (yield Promise.all(calls.map(function(call) {
            return call.build_notification({});
          })));
          notification = {
            _queuer: true,
            host: host,
            now: Date.now(),
            _in: ["number_domain:" + domain],
            calls: result
          };
          _this.socket.emit("queuer:" + name + "-pool", notification);
          debug("queuer:get-" + name + "-pool: done", domain, notification);
        }));
      };
    })(this);
    get_pool('egress', function(domain) {
      return queuer.egress_pool(domain);
    });
    return get_pool('ingress', function(domain) {
      return queuer.ingress_pool(domain);
    });
  };

  this.server_pre = function() {
    var HugePlayAgent, HugePlayCall, HugePlayReference, Queuer, agent_timeout, api, call_timeout, cfg, host, p, pools_redis_interface, port, profile, prov, ref2, ref3, ref4, ref5;
    cfg = this.cfg;
    HugePlayReference = this.cfg.Reference;
    ref2 = this.cfg, api = ref2.api, prov = ref2.prov, host = ref2.host;
    profile = (ref3 = this.cfg.session) != null ? ref3.profile : void 0;
    p = (ref4 = this.cfg.profiles) != null ? ref4[profile] : void 0;
    if (p != null) {
      port = (ref5 = p.egress_sip_port) != null ? ref5 : p.sip_port + 10000;
    }
    if (!((cfg.local_redis_client != null) && (prov != null) && (profile != null) && (host != null) && (port != null) && (api != null) && (HugePlayReference != null))) {
      this.debug.dev('Missing configuration');
      return;
    }
    call_timeout = 8 * 3600;
    agent_timeout = 12 * 3600;
    HugePlayCall = (function(superClass) {
      extend(HugePlayCall, superClass);

      function HugePlayCall() {
        return HugePlayCall.__super__.constructor.apply(this, arguments);
      }

      HugePlayCall.prototype["interface"] = new RedisInterface(cfg.local_redis_client, call_timeout);

      HugePlayCall.prototype.__api = api;

      HugePlayCall.prototype.profile = pkg.name + "-" + profile + "-egress";

      HugePlayCall.prototype.Reference = HugePlayReference;

      HugePlayCall.prototype.build_notification = seem(function*(data) {
        var k, notification, v;
        notification = {
          _queuer: true,
          host: host,
          now: Date.now(),
          domain: this.domain,
          key: this.key,
          id: this.id,
          destination: this.destination,
          call_state: (yield this.state()["catch"](function() {
            return null;
          })),
          remote_number: (yield this.get_remote_number()["catch"](function() {
            return null;
          })),
          alert_info: (yield this.get_alert_info()["catch"](function() {
            return null;
          })),
          reference: (yield this.get_reference()["catch"](function() {
            return null;
          })),
          session: (yield this.get_session()["catch"](function() {
            return null;
          })),
          answered: (yield this.answered()["catch"](function() {
            return null;
          })),
          presenting: (yield this.count()["catch"](function() {
            return null;
          })),
          tags: (yield this.tags()["catch"](function() {
            return [];
          }))
        };
        for (k in data) {
          if (!hasProp.call(data, k)) continue;
          v = data[k];
          if (!(v != null)) {
            continue;
          }
          switch (k) {
            case 'agent':
            case 'call':
            case 'agent_call':
            case 'remote_call':
              if (typeof v !== 'string') {
                v = v.key;
              }
          }
          if (notification[k] == null) {
            notification[k] = v;
          }
        }
        return notification;
      });

      HugePlayCall.prototype.report = seem(function*(data) {
        var notification;
        debug('call.report', data);
        notification = (yield this.build_notification(data));
        cfg.statistics.emit('queuer', notification);
        debug('call.report: send', notification);
      });

      return HugePlayCall;

    })(TaggedCall);
    HugePlayAgent = (function(superClass) {
      extend(HugePlayAgent, superClass);

      function HugePlayAgent() {
        return HugePlayAgent.__super__.constructor.apply(this, arguments);
      }

      HugePlayAgent.prototype["interface"] = new RedisInterface(cfg.local_redis_client, agent_timeout);

      HugePlayAgent.prototype.new_call = function(data) {
        return new HugePlayCall(cfg.queuer, this.domain, data);
      };

      HugePlayAgent.prototype.notify = seem(function*(data) {
        var agent_name, event, notification, offhook, old_state, reason, state;
        debug('agent.notify', this.key, data);
        old_state = data.old_state, state = data.state, event = data.event, reason = data.reason;
        notification = {
          _queuer: true,
          _in: ["endpoint:" + this.key, "number:" + this.key, "number_domain:" + this.domain],
          _notify: true,
          host: host,
          now: Date.now(),
          state: state,
          old_state: old_state,
          event: event,
          reason: reason,
          agent: this.key,
          number: this.number,
          number_domain: this.domain,
          dialplan: 'centrex',
          missed: (yield this.get_missed()["catch"](function() {
            return 0;
          })),
          count: (yield this.count()["catch"](function() {
            return 0;
          }))
        };
        notification.tags = (yield this.tags()["catch"](function() {
          return [];
        }));
        agent_name = (yield (this.get('name'))["catch"](function() {
          return null;
        }));
        if (agent_name != null) {
          notification.agent_name = agent_name;
        }
        offhook = (yield this.get_offhook_call()["catch"](function() {
          return null;
        }));
        if (offhook) {
          notification.offhook = true;
        } else {
          notification.offhook = false;
        }
        if (data.call != null) {
          yield data.call.report(notification);
        } else {
          cfg.statistics.emit('queuer', notification);
        }
        debug('agent.notify: done', this.key, notification);
      });

      HugePlayAgent.prototype.create_egress_call = seem(function*(body) {
        var _id, account, call, call_data, endpoint, options, queuer_webhook, ref6, reference, tags, timezone;
        debug('create_egress_call', this.domain, body);
        if (this.number_domain_data == null) {
          this.number_domain_data = (yield prov.get("number_domain:" + this.domain)["catch"](function(error) {
            return null;
          }));
        }
        if (this.number_domain_data == null) {
          debug('create_egress_call: missing number-domain', this.domain);
          return;
        }
        ref6 = this.number_domain_data, account = ref6.account, queuer_webhook = ref6.queuer_webhook, timezone = ref6.timezone;
        if (timezone == null) {
          timezone = null;
        }
        yield this.set('timezone', timezone);
        if (account == null) {
          debug('create_egress_call: no account', this.domain);
          return null;
        }
        if (body == null) {
          if (queuer_webhook == null) {
            debug('create_egress_call: no queuer_webhook', this.domain);
            return null;
          }
          tags = (yield this.tags());
          options = {
            key: this.key,
            number: this.number,
            domain: this.domain,
            tags: tags
          };
          debug('create_egress_call: send request', options);
          body = (yield request.post(queuer_webhook).send(options)).body;
        }
        if (body.tags == null) {
          body.tags = [];
        }
        if (!((body.destination != null) && (body.tags != null) && (body.tags.length != null))) {
          debug('create_egress_call: incomplete response', this.domain, body);
          return null;
        }
        body.tags.push('queuer');
        debug('create_egress_call: creating call', this.domain, body);
        body.tags.push('egress');
        body.tags.push("number_domain:" + this.domain);
        endpoint = this.key;
        reference = new HugePlayReference();
        _id = reference.id;
        yield reference.add_in(["endpoint:" + endpoint, "number:" + endpoint, "account:" + account, "number_domain:" + this.domain]);
        yield reference.set_endpoint(endpoint);
        yield reference.set_account(account);
        yield reference.set_destination(body.destination);
        yield reference.set_source(this.number);
        yield reference.set_domain(host + ":" + port);
        yield reference.set_block_dtmf(true);
        call_data = {
          uuid: 'create-egress-call',
          session: _id + "-create-egress-call",
          reference: _id,
          start_time: now(timezone),
          source: this.number,
          destination: body.destination,
          timezone: timezone,
          timestamp: now(timezone),
          host: host,
          type: 'call',
          event: 'create-egress-call'
        };
        call = this.new_call({
          destination: _id
        });
        yield call.save();
        yield call.set_remote_number(body.destination);
        yield call.set_tags(body.tags);
        yield call.set('timezone', timezone);
        this.notify(call_data);
        debug('create_egress_call: complete');
        return call;
      });

      return HugePlayAgent;

    })(TaggedAgent);
    pools_redis_interface = new RedisInterface(cfg.local_redis_client, agent_timeout);
    Queuer = queuer(pools_redis_interface, {
      Agent: HugePlayAgent,
      Call: HugePlayCall
    });
    this.cfg.queuer = new Queuer(this.cfg);
  };

  this.include = seem(function*() {
    var Agent, Call, local_server, ref2, uuid;
    if ((yield this.reference.get_block_dtmf())) {
      yield this.action('block_dtmf');
    }
    queuer = this.cfg.queuer;
    if (queuer == null) {
      return;
    }
    ref2 = this.cfg.queuer, Agent = ref2.Agent, Call = ref2.Call;
    if (!((Agent != null) && (Call != null))) {
      return;
    }
    uuid = this.call.uuid;
    this.queuer_call = seem(function*(id) {
      var domain, queuer_call;
      domain = this.session.number_domain;
      if (id == null) {
        id = uuid;
      }
      this.debug('queuer_call', id, domain);
      queuer_call = new Call(queuer, domain, {
        id: id
      });
      yield queuer_call.save();
      yield queuer_call.set_session(this.session._id);
      yield queuer_call.set_reference(this.session.reference);
      return queuer_call;
    });
    local_server = [this.session.local_server, this.session.client_server].join('/');
    this.queuer_login = seem(function*(source, name, fifo, tags, ornaments) {
      var agent;
      if (tags == null) {
        tags = [];
      }
      this.debug('queuer_login', source);
      agent = new Agent(queuer, source);
      yield agent.set('name', name);
      yield agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        yield agent.add_tag("queue:" + fifo.full_name);
      }
      if (ornaments != null) {
        this.agent = agent;
        yield run.call(this, ornaments, this.ornaments_commands);
      }
      yield agent.accept_onhook();
      yield this.report({
        state: 'queuer-login',
        source: source,
        fifo: fifo,
        tags: tags
      });
      return agent;
    });
    this.queuer_leave = seem(function*(source, fifo) {
      var agent;
      this.debug('queuer_leave', source);
      agent = new Agent(queuer, source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        yield agent.del_tag("queue:" + fifo.full_name);
      }
      yield this.report({
        state: 'queuer-leave',
        source: source,
        fifo: fifo
      });
      return agent;
    });
    this.queuer_logout = seem(function*(source, fifo) {
      var agent;
      this.debug('queuer_logout', source);
      agent = new Agent(queuer, source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        yield agent.del_tag("queue:" + fifo.full_name);
      }
      yield agent.clear_tags();
      yield agent.transition('logout');
      yield this.report({
        state: 'queuer-logout',
        source: source,
        fifo: fifo
      });
      return agent;
    });
    return this.queuer_offhook = seem(function*(source, name, arg, fifo, tags) {
      var agent, call, uuid;
      uuid = arg.uuid;
      if (tags == null) {
        tags = [];
      }
      this.debug('queuer_offhook', source, uuid, fifo);
      agent = new Agent(queuer, source);
      yield agent.set('name', name);
      agent.clear_tags();
      yield agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        yield agent.add_tag("queue:" + fifo.full_name);
      }
      call = (yield agent.accept_offhook(uuid));
      if (call == null) {
        return;
      }
      yield call.set_session(this.session._id);
      yield this.report({
        state: 'queuer-offhook',
        source: source,
        fifo: fifo,
        tags: tags
      });
      return agent;
    });
  });

}).call(this);
