// Generated by CoffeeScript 1.12.7
(function() {
  var debug, seem;

  this.name = 'huge-play:middleware:dtmf';

  seem = require('seem');

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var dtmf_buffer, expect, handler, on_change, present, timer, wait_for_digit;
    timer = null;
    handler = null;
    dtmf_buffer = '';
    on_change = null;
    yield this.call.event_json('DTMF');
    this.call.on('DTMF', (function(_this) {
      return function(res) {
        var c;
        c = res.body['DTMF-Digit'];
        debug("Received " + c);
        if (dtmf_buffer == null) {
          dtmf_buffer = '';
        }
        dtmf_buffer += c;
        if (typeof on_change === "function") {
          on_change();
        }
      };
    })(this));
    wait_for_digit = (function(_this) {
      return function(timeout) {
        if (on_change != null) {
          debug.dev("wait_for_digit called while already active (ignore)");
          return Promise.reject(new Error('recursive'));
        }
        return new Promise(function(resolve, reject) {
          var on_timeout;
          on_timeout = function() {
            on_change = null;
            return reject(new Error('timeout'));
          };
          timer = setTimeout(on_timeout, timeout);
          on_change = function() {
            on_change = null;
            clearTimeout(timer);
            return resolve();
          };
        });
      };
    })(this);
    expect = seem((function(_this) {
      return function*(min_length, max_length, inter_digit) {
        var clear, error, m;
        if (min_length == null) {
          min_length = 1;
        }
        if (max_length == null) {
          max_length = min_length;
        }
        if (inter_digit == null) {
          inter_digit = 3 * 1000;
        }
        debug('expect', min_length, max_length, inter_digit);
        clear = function(r) {
          if (r == null) {
            r = dtmf_buffer;
          }
          debug('clear');
          dtmf_buffer = '';
          if (r.length < min_length) {
            return '';
          } else {
            return r.substr(0, max_length);
          }
        };
        while (true) {
          if (m = dtmf_buffer.match(/^([^#]*)#/)) {
            return clear(m[1]);
          }
          if (dtmf_buffer.length >= max_length) {
            return clear();
          }
          try {
            yield wait_for_digit(inter_digit);
          } catch (error1) {
            error = error1;
            return clear();
          }
        }
      };
    })(this));
    present = function() {
      return dtmf_buffer.length > 0;
    };
    this.dtmf = {
      clear: function() {
        var r, ref;
        ref = [dtmf_buffer, ''], r = ref[0], dtmf_buffer = ref[1];
        return r;
      },
      expect: expect,
      playback: seem((function(_this) {
        return function*(url) {
          if (present()) {
            return;
          }
          yield _this.set({
            playback_terminators: '1234567890#*'
          });
          return (yield _this.action('playback', url));
        };
      })(this)),
      phrase: seem((function(_this) {
        return function*(phrase) {
          if (present()) {
            return;
          }
          yield _this.set({
            playback_terminators: '1234567890#*'
          });
          return (yield _this.action('phrase', phrase));
        };
      })(this))
    };
    return null;
  });

}).call(this);
